#include <Application.h> 
#include <InterfaceKit.h> 
#include <StorageKit.h> 
#include <SupportKit.h>

#include <stdlib.h>
#include <stdio.h> 
#include <string.h> 
#include <stdarg.h>
#include <assert.h>

#include <be/add-ons/tracker/TrackerAddon.h> 

// This code is GPL. Will have to look how to include License the right way.

char* GetMailStatus(BNode *node)
{
	assert(node != NULL);
	char *status = (char*)malloc(10);
	for (int i = 0; i < 10; i++)
		status[i] = 0;
	int i = node->ReadAttr("MAIL:status",
		B_STRING_TYPE,
		0,
		(void*)status,10);
	if (i < 0)
		return NULL;
	return status;
}

// This is a tweak I get from MakePending

void SetPending(BNode *node)
{
	int32 magic = 5;
	node->WriteAttr("MAIL:status", B_STRING_TYPE,
					0,(void*)"Pending",8);
	node->WriteAttr("MAIL:flags", B_INT32_TYPE, 0 ,
					&magic, sizeof(int32));
}

void ChangeMailStatus(BEntry *entry)
{
	BNode *node = new BNode(entry);
	node->Lock();
	char * tmp = GetMailStatus(node);
	if (tmp == NULL)
		return;
	BString status = tmp;
	if (!status.Compare("New"))
		node->WriteAttr("MAIL:status", B_STRING_TYPE,
			0,(void*)"Read",5);
	if (!status.Compare("Read"))
		node->WriteAttr("MAIL:status", B_STRING_TYPE,
			0,(void*)"New",4);
	if (!status.Compare("Sent"))
		SetPending(node);
	if (!status.Compare("Pending"))
		node->WriteAttr("MAIL:status", B_STRING_TYPE,
			0,(void*)"Sent",5);
	if (!status.Compare("Error"))
		SetPending(node);
	node->Unlock();
	delete node;
}

void process_refs(entry_ref dir_ref, BMessage *msg, void *toto)
{
	int refs;
	entry_ref file_ref;
	BPath path; 
	BEntry entry(&dir_ref); 
	for (refs = 0; msg->FindRef("refs", refs, &file_ref) == B_NO_ERROR;refs++)
	{
		entry.SetTo(&file_ref);
		ChangeMailStatus(&entry);
	}
}

int main()
{
	new BApplication("application/x-mss-tracker-add-on");
	(new BAlert("", "E-Mail status switcher.\nUse as tracker add-on.", "OK"))->Go();
	delete be_app;
	return 0;
}
